# -*- coding: utf-8 -*-
"""ITS307 - Assignment 01.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1SyO6XLpmDn2X8NCaHtEp7fE89nW03jqT

# ITS307 Data Analytics : Assignment 1

**Gyalpozhing College of Information Technology </br>
Spring Semester 2022**</br>

## Part 1: Drake or Rihanna?

Billboard Magazine puts out a top 100 list of "singles" every week. Information from this list, as well as that from music sales, radio, and other sources is used to determine a top-100 "singles" of the year list. A single is typically one song, but sometimes can be two songs which are on one "single" record.

In this homework you will:

1. Read data from ``yearinfo.json`` which is scraped from Wikipedia to obtain information about the best singers and groups from each year (distinguishing between the two groups) as determined by the Billboard top 100 charts. You will have to clean this data.First you will learn how to read data from json files and create dataframe.

2. Use pandas and matplotlib to represents and explore data

### 1.1 Loading data from json file

Load our JSON file into the ``yearinfo`` variable, just to be sure everything is working.
"""

#Write your code here, You may need to use python open() function to open the file and load data.
import pandas as pd
import json
import matplotlib.pyplot as plt

f = open('yearinfo.json')
yearinfo = json.load(f)
print(yearinfo)

# To print the keys inside the json file
yearinfo.keys()

# To check the number of songs in 2010
len(yearinfo['2010'])

# To print column names inside each year
yearinfo['2010'][0].keys()

#To check out the format of each values
yearinfo['2010'][0].values()

"""### 1.2 Constructing dataframe from `yearinfo`

Construct a year-song-singer dataframe from the yearly information

Let's construct a dataframe **`df`** from the `yearinfo`. The frame should be similar to the frame below. Each row of the frame represents a song, and carries with it the chief properties of year, song, singer, and ranking.

![image-3.png](attachment:image-3.png)

To construct the dataframe, we'll need to iterate over the years and the singles per year. Notice how, above, the dataframe is ordered by ranking and then year. While the exact order is up to you, note that you will have to come up with a scheme to order the information.

Check that the dataframe has sensible data types. You will also likely find that the year field has become an "object" (Pandas treats strings as generic objects): this is due to the conversion to and back from JSON. Such conversions need special care. Fix any data type issues with `df`. (See Pandas astype function.) We will use this `df` in the next question.
"""

#write your code here
# To prepare a column name for use in the DataFrame, which is all the keys, and to include the year in the list.
column = list(yearinfo['2010'][0].keys())+(['year'])
column

# Store the values, along with the year, in a new list.
song_data_lst = []
for key, value in yearinfo.items():
    for i in value:
        data = list(i.values())+[key]
        song_data_lst.append(data)
print(song_data_lst)

# To Create a DataFrame
df = pd.DataFrame(song_data_lst,columns=column)

# print the first 5 data 
df.head()

# To obtain the first band singer from our dataframe,
df.band_singer[0][0]

# Examining the song datatypes in our dataframe
df.dtypes

# Since the year is an object dtype, we will change it to int.
df = df.astype({'year': 'int64'})
df.dtypes

# the data is in the form of a list, we will attempt to remove the brackets.
# function to return the value from a list 
def fetch_list_value(list_name):
    value = list_name[0]
    return value

# Store the value in the desired format.
df['band_singer'] = df.band_singer.map(fetch_list_value)
df['song'] = df.song.map(fetch_list_value)
df['songurl'] = df.songurl.map(fetch_list_value)
df['url'] = df.url.map(fetch_list_value)

# to examine the first 5 data
df.head()

"""### 1.3 Who are the highest quality singers?

Here we show the highest quality singers and plot them on a bar chart.

#### Find highest quality singers according to how prolific they are

What do we mean by highest quality? This is of course open to interpretation, but let's define "highest quality" here as the number of times a singer appears in the top 100 over this time period. If a singer appears twice in a year (for different songs), this is counted as two appearances, not one. 

Make a bar-plot of the most prolific singers. Singers on this chart should have appeared at-least more than 15 times. (HINT: look at the docs for the pandas method `value_counts`.)
"""

#Write your program and plot bar graph
# Return the series in DataFrame with unique rows in ascending order. 
new_df = df.value_counts(subset=['band_singer'], ascending=False)
new_df

#Singers who have appeared more than 15 times will be return. We're limiting value_counts to those greater than 15 in this circumstance.
new_df = new_df.loc[lambda x : x > 15]
new_df

# Plot the most prolific singers who have appeared more than 15 times. 
y = df.band_singer.value_counts().loc[lambda x : x > 15]
x = y.index
plt.bar(x,y)
plt.xticks(rotation=90)
plt.xlabel('band singer')
plt.ylabel('song')
plt.show()

"""**Question: Who is the most profilic singer?**

We may deduce from the preceding data that Drake (musician) is the most prolific singer, having appeared 26 times.

### 1.4 What if we used a different metric?

What we would like to capture is this: a singer should to be scored higher if the singer appears higher in the rankings. So we'd say that a singer who appeared once at a higher and once at a lower ranking is a "higher quality" singer than one who appeared twice at a lower ranking.

To do this, group all of a singers songs together and assign each song a score 101 - ranking. Order the singers by their total score and make a bar chart for the top 20.
"""

#write your code here
#assign a score to each song 101 - ranking
df['score'] = [101-i for i in df['ranking']]
df.head()

# Examine the datatypes
df.dtypes

# Add the singer's total score to the singer's score.
# df.groupby('band_singer').sum() other solution

singer_score = {}

for singer, songs in df.groupby('band_singer'):
    singer_score[singer] = songs.score.sum()

singer_score

# Make a bar chart for the top 20 singers based on their total score.
y = pd.Series(data=singer_score, index=singer_score.keys()).sort_values(ascending=False)[:20]
x = y.index
plt.bar(x,y)
plt.xticks(rotation=90)
plt.xlabel('singer')
plt.ylabel('score')
plt.show()

"""**Question:Do you notice any major differences when you change the metric? How have the singers at the top shifted places? Why do you think this happens?**

When we change the metric, there is a difference. When we look at the number of times Taylor Swift has appeared, she is fourth on the list, but when we look at the scores, Ariana Grande is fourth. This is due to the fact that in the first case, we only consider the number of times the singers appear in the top 100, whereas in the second case, we consider the ranking and then give a higher score to those who appear in the higher ranking. This is a more reasonable way to assess a higher-quality singer. If a singer appears higher in the rankings, he or she should be given a higher score.So a singer who appears once at a higher and once at a lower ranking is of "higher quality" than one who appears twice at a lower ranking.

## Part 2: Using group properties

Frame any questions that you want to answer using group properties and interpret your result using appropriate visualizations.

Which singer of which song received the highest ranking in each year?
"""

#write your solution from here

#grouping the singers by year and printing the highest ranked singer in each year
for key, value in df.groupby('year'):
    highestdf = value[value.ranking == value.ranking.max()]
    print(highestdf.year, highestdf.band_singer)

"""The singer Jerrod Niemann of band_singer received the highest ranking in the year 2010

## SUBMISSION DATE: 2nd April 2022
"""